/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;

import mcp.MethodsReturnNonnullByDefault;
import net.dries007.tfc.world.classic.CalenderTFC;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public class TESaplingTFC extends TileEntity
{
    private long timer;

    public TESaplingTFC()
    {
        super();
    }

    public long getHoursSincePlaced()
    {
        return CalenderTFC.getTotalHours() - timer;
    }

    public void onPlaced()
    {
        timer = CalenderTFC.getTotalHours();
        this.func_70296_d();
    }

    @Override
    public void func_145839_a(NBTTagCompound tag)
    {
        timer = tag.func_74763_f("timer");
        super.func_145839_a(tag);
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag)
    {
        tag.func_74772_a("timer", timer);
        return super.func_189515_b(tag);
    }

    @Override
    @Nullable
    public SPacketUpdateTileEntity func_189518_D_()
    {
        if (field_145850_b != null)
        {
            return new SPacketUpdateTileEntity(this.func_174877_v(), 0, this.func_189515_b(new NBTTagCompound()));
        }

        return null;
    }

    @Override
    public NBTTagCompound func_189517_E_()
    {
        /* The tag from this method is used for the initial chunk packet, and it needs to have the TE position!
        but this should be already handled by writeToNBT, not tested tho
        NBTTagCompound nbt = new NBTTagCompound();
        nbt.setInteger("x", this.getPos().getX());
        nbt.setInteger("y", this.getPos().getY());
        nbt.setInteger("z", this.getPos().getZ());*/
        return func_189515_b(/*nbt*/new NBTTagCompound());
    }

    @Override
    public void onDataPacket(NetworkManager net, SPacketUpdateTileEntity packet)
    {
        this.handleUpdateTag(packet.func_148857_g());
    }

    @Override
    public void handleUpdateTag(NBTTagCompound tag)
    {
        func_145839_a(tag);
    }
}
